unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    mmo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
myDebug;

var
  DB: TDebugger;

procedure MySystemLog(const sLog: string);
begin
  Form1.mmo1.Lines.Add('[>] ' + sLog)
end;

procedure MySingleStep(const ERec : _EXCEPTION_RECORD);
var
  s   : string;
  adr : dword;
begin
  adr := DWORD(ERec.ExceptionAddress);
  s:= IntToHex(adr,8);
  Form1.mmo1.Lines.Add(s)
end;

procedure RunDebuger();
var
  dwState  : dword;
  dwReason : dword;
  //disasm   : TDisasmOptions;
begin
  DB := TDebugger.Create;

  DB.iHideDdg          := 1;
  DB.iSetEpBreak       := 1;
  DB.iHandleDll        := 1;

  //DB.SystemBpHandler   := DWORD(@MySystemBp);
  //DB.Int3Handler       := DWORD(@MyInt3);

  DB.SingleStepHandler := DWORD(@MySingleStep);
  DB.LogHandler := DWORD(@MySystemLog);

  //  ! DB.SetHardwareBreak()

  If (DB.RunDebug('Project11.exe') = 1) then
  begin
    repeat
      If (DB.DoDebugLoop(dwState, dwReason) = DEBUG_EVENT) then
      begin
        If (dwReason = EP_HANDLER) then
        begin
          //  entrypoint
        end;
        If (dwReason = BPH_HANDLER) then
        begin
          //   
          //  ,  
        end;
      end else
      begin
        Sleep(1);          // sleep
        Application.ProcessMessages;
      end;
    until (dwState = PROCESS_TERMINATED);
  end;

  //LOG('[!] Finished');
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
 RunDebuger();

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  DB.TerminateDebug();

end;

end.
